/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.wahlbeteiligung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.wahlbeteiligung.boundary.AbstractWahlbeteiligungVerlaufGebietSearchParameters;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungVerlaufGebietChangeEvent;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungVerlaufGebietConversationStore;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungVerlaufGebietExtendedDAO;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungVerlaufGebietSearch;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungVerlaufGebietSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebietMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractWahlbeteiligungVerlaufGebietSearchView.COMPONENT_NAME)
@View(viewId = AbstractWahlbeteiligungVerlaufGebietSearchView.VIEW_ID, useCase = UseCasePermission.WAHLBETEILIGUNG_VERLAUF_GEBIET_SEARCH)
public abstract class AbstractWahlbeteiligungVerlaufGebietSearchView extends AbstractElectSearchView<WahlbeteiligungVerlaufGebiet> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlbeteiligungVerlaufGebietSearchView";
  
  public static final String VIEW_ID = "/wahlbeteiligung/wahlbeteiligung-verlauf-gebiet-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractWahlbeteiligungVerlaufGebietSearchView requestHandler;

  @Inject
  private transient WahlbeteiligungVerlaufGebietExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(WahlbeteiligungVerlaufGebietConversationStore.class)
  protected transient WahlbeteiligungVerlaufGebietConversationStore conversationStore;

  @Inject
  protected transient WahlbeteiligungVerlaufGebietSearch search;

  @Inject
  @ConversationGroup(AbstractWahlbeteiligungVerlaufGebietSearchParameters.class)
  protected transient WahlbeteiligungVerlaufGebietSearchParameters searchParameters;

  @Inject
  protected transient WahlbeteiligungVerlaufGebietMeta entityMeta;

  public AbstractWahlbeteiligungVerlaufGebietSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public WahlbeteiligungVerlaufGebiet getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(WahlbeteiligungVerlaufGebiet entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public WahlbeteiligungVerlaufGebietSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<WahlbeteiligungVerlaufGebiet> getEagerLoadingCollector() {
    return EagerLoadingCollector.<WahlbeteiligungVerlaufGebiet> create();
  }

  @Override
  public List<WahlbeteiligungVerlaufGebiet> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<WahlbeteiligungVerlaufGebiet> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onWahlbeteiligungVerlaufGebietChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlbeteiligungVerlaufGebietChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //   Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractWahlbeteiligungVerlaufGebietSearchView {

    @View
    @Inject
    private transient Instance<AbstractWahlbeteiligungVerlaufGebietSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractWahlbeteiligungVerlaufGebietSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
